import React from 'react';
import { StylingFunction } from 'react-base16-styling';
export declare type Key = string | number;
export declare type KeyPath = readonly (string | number)[];
export declare type GetItemString = (nodeType: string, data: unknown, itemType: React.ReactNode, itemString: string, keyPath: KeyPath) => React.ReactNode;
export declare type LabelRenderer = (keyPath: KeyPath, nodeType: string, expanded: boolean, expandable: boolean) => React.ReactNode;
export declare type ValueRenderer = (valueAsString: unknown, value: unknown, ...keyPath: KeyPath) => React.ReactNode;
export declare type ShouldExpandNodeInitially = (keyPath: KeyPath, data: unknown, level: number) => boolean;
export declare type PostprocessValue = (value: unknown) => unknown;
export declare type IsCustomNode = (value: unknown) => boolean;
export declare type SortObjectKeys = ((a: unknown, b: unknown) => number) | boolean;
export declare type Styling = StylingFunction;
export declare type CircularCache = unknown[];
export interface CommonExternalProps {
    keyPath: KeyPath;
    labelRenderer: LabelRenderer;
    valueRenderer: ValueRenderer;
    shouldExpandNodeInitially: ShouldExpandNodeInitially;
    hideRoot: boolean;
    getItemString: GetItemString;
    postprocessValue: PostprocessValue;
    isCustomNode: IsCustomNode;
    collectionLimit: number;
    sortObjectKeys: SortObjectKeys;
}
export interface CommonInternalProps extends CommonExternalProps {
    styling: StylingFunction;
    circularCache?: CircularCache;
    level?: number;
    isCircular?: boolean;
}
